
<template>
    <form class="form"
          novalidate
          @submit.prevent="handleSubmit"
          enctype="multipart/form-data">
        <RegleBaseForm :regle="regle"

                       :title="t('regle.info')"
                       @handle-validation="handleValidation"
                       @register-form-input-ref="addFormInputRef">

            </RegleBaseForm>

            <button v-if="!props.regle" class="form__submit btn btn--fullscreen" type="submit">
                {{ t("global.add") }}
            </button>
            <button v-else class="form__submit btn btn--fullscreen" type="submit">
                {{ t("global.save") }}
            </button>
    </form>
</template>

<script lang="ts" setup>

    import FormInput from "@/components/forms/FormInput.vue"
    import RegleBaseForm from "@/components/regles/RegleBaseForm.vue"
import {ref} from "vue"
import {useI18n} from "vue3-i18n"
import {notifyError} from "@/notify"
    import { Status } from "@/validation"
    import { Regle } from "@/types/entities"

// eslint-disable-next-line no-undef
    const props = defineProps<{
        regle?: Regle
}>()

// eslint-disable-next-line
    const emit = defineEmits<{
        (event: "formSubmit", regle: Regle): void
    }>()

    // eslint-disable-next-line
    defineExpose({
        mettreRouge,

    })

const { t } = useI18n()

    const regle = ref<Regle>(props.regle ?? {})

const formInputs = ref<any[]>([])
const inputValidationStatuses:any = {}

function addFormInputRef(ref: typeof FormInput) {
    if (!formInputs.value.includes(ref) && ref)
        formInputs.value.push(ref)
    }



async function handleValidation(name: string, validationStatus: Status) {
    inputValidationStatuses[name] = validationStatus.valid
    }

    async function mettreRouge() {
        formInputs.value[0].mettreRougePourRegle()
    }

    async function handleSubmit() {
    formInputs.value.forEach((x: typeof FormInput) => x.validateInput())
    if (Object.values(inputValidationStatuses).some(x => x === false)) {
        notifyError(t('global.formErrorNotification'))
        return
    }
    emit("formSubmit", regle.value)
}
</script>